use warnings;
use strict;
use Test::More tests => 2;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


package FlagClass;
our ($Flag, $MyFlag);
sub ALARM  { $Flag++   }
sub MyFlag { $MyFlag++ }
package main;


# is default {method} will be 'ALARM'?
$FlagClass::Flag = 0;
set_timer({ cb=>'FlagClass', for=>0.1 });
sleep 0.1;
run_callback(@$_) for get_expired_timers();
is($FlagClass::Flag, 1, 'default method ALARM was executed');

# can we set custom {method}?
$FlagClass::MyFlag = 0;
set_timer({ cb=>'FlagClass', method=>'MyFlag', for=>0.1 });
sleep 0.1;
run_callback(@$_) for get_expired_timers();
is($FlagClass::MyFlag, 1, 'custom method MyFlag was executed');

