use warnings;
use strict;
use Test::More tests => 6;
use Test::Exception;

use Time::HiRes qw( sleep );

use POWER::Event::Timer qw( :ALL );
use POWER::Utils;


my $Flag = 0;
sub flag { $Flag++ }


my ($timer, @events);

# can we set up one-shot timer?
$timer = set_timer({ cb => \&flag, for => 0.2 });
ok(defined $timer, 'set_timer returned TIMER');

# is this timer will expire timely?
sleep 0.1;
@events = get_expired_timers();
is(@events, 0, 'no timers expired yet');
sleep 0.1;
@events = get_expired_timers();
is(@events, 1, '1 timer expired');

# is expired timer's callback can be executed?
$Flag = 0;
run_callback(@$_) for @events;
is($Flag, 1, 'flag() was executed');

# is expired timer was automatically stopped?
is(get_timers_idle_time(), undef, 'no more timers');
throws_ok { stop_timer($timer) } qr/no such timer/;

